<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Advanced JS Homework 1</title>
</head>
<body>
    <h1>Поясніть своїми словами, як ви розумієте, як працює прототипне наслідування в Javascript</h1>
    <p>

        Прототипне наслідування в Javascript дозволяє зменшити дублювання коду завдяки DRY,
        (Don`t repeat yourself). Наприкладі маючи один об'єкт з методами наприклад "пити" та "спати",
        а також є інший об'єкт з методом "спати", то ми можемо записати у прототип об'єкту  
        клас Animal. Таким чином, ми матимемо можливість через Rabbit.sleep() звернутися до 
        методу "сидіти", хоча безпосередньо клас має лише метод
        "спати". Тобто в цьому випадку я так розумію, двигун Javascript не знайшов метод у самому 
        об'єкті, але знайшов цей метод у прототипі цього класу.
        Прототипне наслідування дозволяє створювати ланцюжки прототипів, де об'єкт може 
        успадковувати властивості і методи не тільки від одного прототипу, але і від 
        прототипів його прототипів і так далі. В моєму розуміні, це надає гнучкість у створенні ієрархії об'єктів 
        у JavaScript. 

    </p>

    <h2>Для чого потрібно викликати super() у конструкторі класу-нащадка?</h2>
    <p>
        super() у конструкторі класу-нащадка потрібно викликати щоб забезпечити ініціалізацію 
        конструктора батьківського класу. Також за допомогою виклика super() ми можемо передати
        аргументи батьківському конструктору, тобто якщо конструктор батьківського класу 
        приймає аргументи, виклик super() дозволяє передати ці аргументи до конструктора
        батьківського класу.
    </p>

    <script src="./main.js"></script>
</body>
</html>